/** Copyright (C) 2017 by Bundesanstalt für Gewässerkunde
 * Software engineering by
 *  Björnsen Beratende Ingenieure GmbH
 *  Dr. Schumacher Ingenieurbüro für Wasser und Umwelt
 *
 * This file is Free Software under the GNU AGPL (>=v3)
 * and comes with ABSOLUTELY NO WARRANTY! Check out the
 * documentation coming with Dive4Elements River for details.
 */
package org.dive4elements.river.model;

/**
 * Enumerations that allows to access min/max/mean value of {@link BedHeight} in the same way.
 *
 * @author Gernot Belger
 *
 */
public enum BedHeightValueType {
    min {
        @Override
        public Double getValue(final BedHeightValue bedheightValue) {
            return bedheightValue.getMinHeight();
        }
    },
    max {
        @Override
        public Double getValue(final BedHeightValue bedheightValue) {
            return bedheightValue.getMaxHeight();
        }
    },
    value {
        @Override
        public Double getValue(final BedHeightValue bedheightValue) {
            return bedheightValue.getHeight();
        }
    };

    public abstract Double getValue(final BedHeightValue bedheightValue);
}